﻿@page "/filmes/avaliacoes"
@inject HttpClient Http
@using System.Collections.Generic
@inject IJSRuntime JSRuntime
@using CadastroAtletasWasm.Helpers
@using CadastroAtletasWasm.Models

<PageTitle>Avaliações</PageTitle>

<h1>Avaliar Filmes</h1>

@if (avaliacoes == null)
{
    <p><em>Loading...</em></p>
}
else
{
    <div class="card">
        <label>FILME</label>
        <select @bind="@newAvaliacao.FilmeId">
            <option>SELECIONE UM FILME</option>
            @foreach (var filme in movies)
            {
                <option value="@filme.Id">@filme.Titulo</option>
            }
        </select>

        <div>
            <div>
                <label>EMAIL</label><br />
                <input type="text" @bind="@newAvaliacao.EmailAvaliador" />
            </div>
            <div>
                <label>COMENTÁRIO SOBRE O FILME - ATENÇÃO **SEM SPOILER**</label><br />
                <textarea id='comentario' @bind="@newAvaliacao.Comentario"></textarea>
            </div>
            <div>
                <label>AVALIAÇÃO</label><br />
                <select @bind="@newAvaliacao.NotaAvaliacao">
                    <option>AVALIE O FILME COM UMA NOTA</option>
                    @for (int i = 1; i <= 10; i++)
                    {
                        <option>@i</option>
                    }
                </select>
            </div>
        </div>
        @if(avaliacaoToEdit == null)
        {
            <button class='btn btn-primary' @onclick="Gravar">ADICIONAR NOVA AVALIAÇÃO</button>
        }
        else
        {
            <button class='btn btn-primary' @onclick="Gravar">EDITAR AVALIAÇÃO</button><br>
            <button class='btn btn-danger' @onclick="Reset">CANCELAR</button>
        }
    </div>
    <div class="card mt-2">
        <label>LISTA DE AVALIAÇÕES</label>
        <div class="table-responsive-lg">
            <table class="table table-hover table-striped">
                <thead>
                    <tr>
                        <th>FILME</th>
                        <th>EMAIL DO AVALIADOR</th>
                        <th>COMENTÁRIO SOBRE O FILME</th>
                        <th>AVALIAÇÃO DO FILME '0-10'</th>
                        <th>AÇÕES</th>
                    </tr>
                </thead>
                <tbody>
                    @foreach (var avaliacao in avaliacoes)
                    {
                        <tr>
                            <td>@GetFilmeTitulo(avaliacao.FilmeId)</td>
                            <td>@avaliacao.EmailAvaliador</td>
                            <td>@avaliacao.Comentario</td>
                            <td>@avaliacao.NotaAvaliacao</td>
                            <td>
                                <button class="btn btn-primary btn-sm" @onclick="(() => Alterar(avaliacao))">Editar</button>
                                <button class="btn btn-danger btn-sm" @onclick="(() => Excluir(avaliacao.Id))">Excluir</button>
                            </td>
                        </tr>
                    }
                </tbody>
            </table>
        </div>
    </div>
}

@code {
    
    private AcessoApi<Filme> apiFilmes = new AcessoApi<Filme>("api/filme");

    private IList<Filme>? movies;

    private AcessoApi<Avaliacao> apiAvaliacoes = new AcessoApi<Avaliacao>("api/avaliacao");

    private IList<Avaliacao>? avaliacoes;

    private Avaliacao newAvaliacao = new Avaliacao();

    private Avaliacao? avaliacaoToEdit;

    protected override async Task OnInitializedAsync()
    {
        movies = await apiFilmes.RetornarTodosAsync();
        avaliacoes = await apiAvaliacoes.RetornarTodosAsync();
    }

    private async Task Gravar()
    {
        if (string.IsNullOrEmpty(newAvaliacao.FilmeId))
        {
            await JSRuntime.InvokeVoidAsync("alert", "Por favor, selecione um filme.");
            return;
        }

        if (string.IsNullOrEmpty(newAvaliacao.EmailAvaliador))
        {
            await JSRuntime.InvokeVoidAsync("alert", "Por favor, informe um e-mail.");
            return;
        }

        if (string.IsNullOrEmpty(newAvaliacao.Comentario))
        {
            await JSRuntime.InvokeVoidAsync("alert", "Por favor, digite um comentário.");
            return;
        }

        if (avaliacaoToEdit == null)
        {
            await apiAvaliacoes.InserirAsync(newAvaliacao);
        }
        else
        {
            newAvaliacao.Id = avaliacaoToEdit.Id;
            await apiAvaliacoes.AlterarAsync(newAvaliacao);
            avaliacaoToEdit = null;
        }

        newAvaliacao = new Avaliacao();
        avaliacoes = await apiAvaliacoes.RetornarTodosAsync();
        this.StateHasChanged();
        ClearForm();
 
    }

    private void Alterar(Avaliacao objeto)
    {
        avaliacaoToEdit = new Avaliacao
        {
            Id = objeto.Id,
            FilmeId = objeto.FilmeId,
            EmailAvaliador = objeto.EmailAvaliador,
            Comentario = objeto.Comentario,
            NotaAvaliacao = objeto.NotaAvaliacao
        };
        newAvaliacao = new Avaliacao
        {
            FilmeId = objeto.FilmeId,
            EmailAvaliador = objeto.EmailAvaliador,
            Comentario = objeto.Comentario,
            NotaAvaliacao = objeto.NotaAvaliacao
        };
    }

    private async void Excluir(string? id)
    {
        if (id != null)
        {
            await apiAvaliacoes.ExcluirAsync(id);
            avaliacoes = await apiAvaliacoes.RetornarTodosAsync();
            this.StateHasChanged();
        }
    }

    private void Reset()
    {
        avaliacaoToEdit = null;
        ClearForm();
    }

    private void ClearForm()
    {
        newAvaliacao.FilmeId = string.Empty;
        newAvaliacao.EmailAvaliador = string.Empty;
        newAvaliacao.Comentario = string.Empty;
        newAvaliacao.NotaAvaliacao = 0;
    }

    private string GetFilmeTitulo(string filmeId)
    {
        var filme = movies.FirstOrDefault(f => f.Id == filmeId);
        return filme?.Titulo ?? "";
    }

    public class Avaliacao : IModelo
    {
        public string? Id { get; set; }

        public string FilmeId { get; set; }

        public string EmailAvaliador { get; set; }

        public string Comentario { get; set; }
        
        public double NotaAvaliacao { get; set; }

    }

    public class Filme : IModelo
    {
        public string? Id { get; set; }
        
        public string Titulo { get; set; } = "";

        public string Descricao { get; set; }

        public string Classificacao { get; set; }
    }
}
